#!/bin/bash

# Setup and start a demoing setup with 1 master and two nodes on the same host.

echo "Starting mapwoc components."

export PYTHONPATH=$PYTHONPATH:.:mapwocgui
export PERL5LIB=analyser/src/lib/:$PERL5LIB
export PATH=$PATH:../mitmproxy

# TODO Copy data from demo-setup to respective places

# It is important to first start the node, such that the master will
# be able to sync hcs with it.

# Start first NodeCtrl (wocexpress)
python mapwoc/nodectrl/twisted_node.py --config demo-setup/node1/node.config --verbose &
NODECTRL1_PID="$!"
statcode=$?
if [ $statcode -ne 0 ]
then
  echo "Could not start the NodeCtrl 1."
  kill 0
  exit 1
fi

echo "Waiting for node to settle."
sleep 2

# Start MasterCtrl
python mapwoc/masterctrl/twisted_master.py --config demo-setup/master/masterctrl.config --quiet &
MASTERCTRL_PID="$!"

statcode=$?
if [ $statcode -ne 0 ]
then
  echo "Could not start the MasterCtrl."
  exit 1
fi

# (Disabled) Start second NodeCtrl (wocfriend)
#python mapwoc/nodectrl/nodectrl.py --config demo-setup/node2/node.config --quiet &
NODECTRL2_PID="$!"
statcode=$?
if [ $statcode -ne 0 ]
then
  echo "Could not start the NodeCtrl 2."
  kill 0
  exit 1
fi

# Start the Redirector
#python mapwoc/redirector/redirector.py --config demo-setup/redirector/redirector.config --urllist demo-setup/redirector/demo.list &
REDIRECTOR_PID="$!"
stat=$?
if [ $stat -ne 0 ]
then
  echo "Could not start the Redirector."
  kill 0
  exit 1
fi

# Kill children when received sigint sigterm or exit.
trap "kill 0" INT TERM EXIT

wait

